#!/bin/bash

git clone https://github.com/jedisct1/webassembly-benchmarks.git

cp -a webassembly-benchmarks/2022-12/wasm wasm-files

libsodium_CASES="aead_aegis128l aead_aegis256 aead_chacha20poly13052 aead_chacha20poly1305
                 aead_xchacha20poly1305 auth2 auth3 auth5 auth6 auth7 auth box2 box7 box8
                 box_easy2 box_easy box_seal box_seed box chacha20 codecs core3
                 core_ed25519_h2c core_ed25519 core_ristretto255 ed25519_convert
                 generichash2 generichash3 generichash hash3 hash kdf_hkdf kdf keygen kx
                 metamorphic onetimeauth2 onetimeauth7 onetimeauth pwhash_argon2id
                 pwhash_argon2i pwhash_scrypt_ll pwhash_scrypt randombytes scalarmult2
                 scalarmult5 scalarmult6 scalarmult7 scalarmult8 scalarmult_ed25519
                 scalarmult_ristretto255 scalarmult secretbox2 secretbox7 secretbox8
                 secretbox_easy2 secretbox_easy secretbox secretstream_xchacha20poly1305
                 shorthash sign2 sign siphashx24 sodium_utils stream2 stream3 stream4
                 stream verify1 xchacha20"

WAMRC_CMD=wamrc

OUT_DIR=$PWD/out
mkdir -p ${OUT_DIR}

for case in $libsodium_CASES
do
    $WAMRC_CMD -o ${OUT_DIR}/${case}.aot wasm-files/${case}.wasm
done
